import os, sys
import numpy as np

root = sys.argv[1]
log_paths = [os.path.join(root, f) for f in os.listdir(root) if f.endswith('log')]

records = {}
for lp in log_paths:
    records[lp] = [0., 0.] # iter, p@k
    with open(lp) as f:
        for i, line in enumerate(f):
            if 'p@k' in line and not line.startswith('prec'):
                line = line.strip().split()
                iter_num = float(line[1])
                prec_k = np.array([float(_p) for _p in line[12:13]]).mean()

                if prec_k > records[lp][-1]:
                    records[lp][0] = iter_num
                    records[lp][-1] = prec_k
for i in range(5):
    params = sorted(records.items(), key=lambda x: (-x[-1][-1], x[0]))[i]
    print("%f %d"%tuple(params[1][::-1]), ' '.join(params[0].split('/')[-1][:-4].split('_')))
