import os, sys
import numpy as np
from scipy.sparse import csr_matrix
from scipy.io import mmwrite
import torch
from torch.nn import functional as F
from util import read_data, csr2tensor
from sklearn.metrics import roc_auc_score
import xclib.evaluation.xc_metrics as xc_metrics
from collections import Counter

_, Yte = read_data(sys.argv[1], True)
Y2 = csr2tensor(Yte.Label)
Y_real = Yte.Label.copy()
Y_real.data = 1*(Y_real.data > 0)
#print(np.unique(Y2._values()))
P2, Q2 = np.load(sys.argv[2]), np.load(sys.argv[3])
P2, Q2 = torch.tensor(P2), torch.tensor(Q2)
p_a_te = torch.mm(P2, Q2.T)
#p_a_te = torch.Tensor(1.0/Yte.IPS.toarray())

print('='*10)
if sys.argv[4] == 'policy':
    p_a_te = F.softmax(p_a_te, dim = 1)
    print('(P) Average Var: %.6f'%torch.mean(torch.var(p_a_te, dim=1)))
    #print('(P) Average Mean: %.6f'%torch.mean(torch.mean(p_a_te, dim=1)))
else:
    p_a_te = torch.sigmoid(p_a_te)
    print('(V) Average Var: %.6f'%torch.mean(torch.var(p_a_te, dim=1)))
    print('(V) Average Mean: %.6f'%torch.mean(torch.mean(p_a_te, dim=1)))

if sys.argv[4] != 'policy':
    p_te = p_a_te[Y2._indices()[0, :], Y2._indices()[1, :]]
    #print('Auc:%.4f'%roc_auc_score(Y2._values().numpy(), p_te.numpy()))#, labels=[-1, 1]))
    p_a_te = p_a_te/p_a_te.sum(dim=1, keepdim=True)
    #p_a_te = F.softmax(p_a_te, dim = 1)

p_e_te = p_a_te[Y2._indices()[0, :][Y2._values() == 1], Y2._indices()[1, :][Y2._values() == 1]]
#print('Expected Va-reward:%.4f'%torch.sum(p_e_te))

max_ids = torch.argmax(p_a_te, dim=1)
c_a_te = torch.zeros_like(p_a_te)
c_a_te[np.arange(p_a_te.shape[0]), max_ids] = 1
c_a_te = c_a_te[Y2._indices()[0, :][Y2._values() == 1], Y2._indices()[1, :][Y2._values() == 1]]
greedy_reward_te = c_a_te #* w2._values()[Y2._values() == 1]
print('Greedy Va-reward:%.4f'%torch.sum(greedy_reward_te))
#_precision = xc_metrics.precision(Y_hat, Y_real, k=1)
#print(_precision, _precision*Y_hat.shape[0])

#res_idx = reward._values()>0
#res = csr_matrix(((reward._values()[res_idx]).numpy(), \
#        ((reward._indices()[0][res_idx]).numpy(), \
#        (reward._indices()[1][res_idx]).numpy())), \
#        shape=reward.shape)
#mmwrite(os.path.join(os.path.dirname(sys.argv[2]), 'gr.mm'), res)
#print(Counter(max_id))
#print(Counter(reward._indices()[1,:][reward._values() > 0].numpy()))
