import numpy as np
import scipy as sp
import os, sys
from utils import *
from sklearn.datasets import load_svmlight_file
from collections import deque
from tensorboardX import SummaryWriter 

np.random.seed(0)


data_root = sys.argv[1]
P = np.load(sys.argv[2])
Q = np.load(sys.argv[3])

writer = SummaryWriter("runs/hist_%s"%(sys.argv[4]))
with open(data_root, 'rb') as fin:
    X, y = load_svmlight_file(fin, multilabel=True)
    eva = Evaluator(P, Q, X, y, 0.0, 2**20, 1.0)
    print('expected reward:', sum(eva.get_exp_reward(writer)))
    for p in ['e_greedy', 'is']:
        actions, pps = eva.take_action(p)
        rewards = eva.get_emp_reward(actions)
        print(p+' reward:', sum(rewards))
