#!/bin/bash

root=$1
replay=1
temp=1.0
tK=100
eps=0.01
pos=$2
noise_scale=0.0
alpha=1.0

cdir=`pwd`
ds=`basename ${root} | cut -d'_' -f1`
data_dir=`basename $root`"_logged_pos${pos}_t${temp}_n${noise_scale}_r${replay}_a${alpha}"
mkdir -p $data_dir

cd ./$data_dir
for f in 'rest.svm' 'label.svm' 'te.svm'
do
    ln -sf `realpath ${cdir}/${root}/$f` ./$f
done
ln -sf `realpath ${cdir}/${root}/rest_tr.svm` ./logged_tr.svm
ln -sf `realpath ${cdir}/${root}/rest_va.svm` ./logged_va.svm
ln -sf te.svm logged_te.svm

num_trva=`wc -l rest.svm | cut -d' ' -f1`
num_te=`wc -l te.svm | cut -d' ' -f1`
num_logged_tr=`wc -l logged_tr.svm | cut -d' ' -f1`
num_logged_va=`wc -l logged_va.svm | cut -d' ' -f1`

## replay function
replay_data()
{
    for j in `seq 1 ${replay}`
    do
        echo "python ../trva_proc.py ./logged_${1}.svm ../$ds/P_rest.npy ../$ds/Q_rest.npy ${temp} ${2} ${3} ${j} ${pos} ${4} ${noise_scale} ${eps} ${tK} ${alpha}"
    done
}

for j in 'is' 'uniform'
do
    # generate data and replay
    echo "dealing with tr"
    replay_data tr 0 ${num_logged_tr} $j | xargs -0 -d '\n' -P 8 -I {} sh -c {}
    echo "dealing with va"
    replay_data va ${num_logged_tr} ${num_trva} $j | xargs -0 -d '\n' -P 8 -I {} sh -c {}

    # merge data
    for i in 'tr' 'va'
    do
        cat logged_${i}.${j}.svm.part* > logged_${i}.replay${replay}.${j}.svm
        rm logged_${i}.${j}.svm.part*
        cat logged_${i}.${j}.plm.part* > logged_${i}.replay${replay}.${j}.plm
        rm logged_${i}.${j}.plm.part*
        cat logged_${i}.${j}.tpk.part* > logged_${i}.replay${replay}.${j}.tpk
        rm logged_${i}.${j}.tpk.part*
    done
done

num_va=$(echo "scale=0;${num_logged_va}*${pos}" | bc -l)
for j in 'is' 'uniform'
do
    head -n ${num_va} logged_va.replay${replay}.${j}.tpk | awk "NR % ${pos} == 0" > logged_va.${j}.tpk
    python ../trva_proc.py ./logged_te.svm ../$ds/P_te.npy ../$ds/Q_te.npy ${temp} 0 ${num_te} 1 ${pos} ${j} ${noise_scale} ${eps} ${tK} ${alpha}
    awk "NR % ${pos} == 0" logged_te.${j}.tpk.part1 > logged_te.${j}.tpk
    rm logged_te.${j}.*.part1
done

cd ${cdir}
