import sys

if len(sys.argv) not in [4, 5]:
    print('Usage: python clean_labels.py path/to/train path/to/test path/to/label [path/to/output/tr_ids]')
    exit(1)

path_tr = sys.argv[1]
path_te = sys.argv[2]
path_label = sys.argv[3]
if len(sys.argv) == 5:
    path_tr_ids = sys.argv[4]

labels_dict = {}
feats_dict = {}

i2tr = {}
with open(path_tr) as f, open(path_tr +".clean", 'w') as f_tr:
    cnt = 0
    for i, line in enumerate(f):
        labels, features = line.rstrip().split(' ', maxsplit=1)
        labels = labels.split(',')
        new_labels = []
        for label in labels:
            if label == '':
                continue
            label = int(label)
            new_label_idx = labels_dict.get(label, len(labels_dict))
            labels_dict[label] = new_label_idx
            new_labels.append(new_label_idx)
        if not new_labels:
            continue
        new_feats = []
        features = features.strip().split(' ')
        for feat in features:
            feat_idx, value = feat.split(':')
            new_feat_idx = feats_dict.get(feat_idx, len(feats_dict))
            feats_dict[feat_idx] = new_feat_idx 
            new_feats.append((new_feat_idx, value))
        new_labels = [str(i) for i in sorted(new_labels)]
        new_feats = [":".join([str(i[0]), str(i[1])]) for i in sorted(new_feats, key=lambda x: x[0])]
        new_feature_set = ' '.join(new_feats)
        print(','.join(new_labels), new_feature_set, file=f_tr)
        i2tr[i] = cnt
        cnt += 1


tr_ids = []
with open(path_te) as f, open(path_te+".clean", 'w') as f_te:
    for i, line in enumerate(f):
        if len(sys.argv) == 5 and i not in i2tr:
            continue
        labels, features = line.rstrip().split(' ', maxsplit=1)
        labels = labels.split(',')
        new_labels = []
        for label in labels:
            if label == '':
                continue
            label = int(label)
            if label not in labels_dict:
                continue
            new_label_idx = labels_dict[label]
            new_labels.append(new_label_idx)
        if not new_labels:
            continue
        new_feats = []
        features = features.strip().split(' ')
        for feat in features:
            feat_idx, value = feat.split(':')
            if feat_idx in feats_dict:
                new_feat_idx = feats_dict[feat_idx]
            else:
                continue
            new_feats.append((new_feat_idx, value))
        if not new_feats:
            continue
        new_labels = [str(i) for i in sorted(new_labels)]
        new_feats = [":".join([str(i[0]), str(i[1])]) for i in sorted(new_feats, key=lambda x: x[0])]
        new_feature_set = ' '.join(new_feats)
        print(','.join(new_labels), new_feature_set, file=f_te)
        tr_ids.append(i2tr[i])

with open(path_label) as f, open(path_label+".clean", 'w') as f_label:
    for i, line in enumerate(f):
        if i in labels_dict:
            print(line.rstrip(), file=f_label)

if len(sys.argv) == 5:
    with open(path_tr_ids, 'w') as f:
        for tr_id in tr_ids:
            print(tr_id, file=f)

print("label_size:", len(labels_dict))
print("feat_size:", len(feats_dict))

print("Run the following:")
for path in [path_tr, path_te, path_label]:
    print("mv {} {}".format(path+".clean", path))
